import java.util.ArrayList;
import java.util.Iterator;

/* Anmerkung:  Die Klasse soll hauptschlich exemplarisch 
 * die Nutzung von Schleifen und Listen zeigen. 
 */
public class Zahlenanalyse {
  private ArrayList<Integer> zahlen;
  private String name = "default";

  public Element minimum() {
    if (this.zahlen == null || this.zahlen.size() == 0){
      return new Element(-100000,-1); // nur sinnvoll, wenn diese Zahl nicht vorkommen kann
                      // real: eigene Exception werfen
    }
    int minimum = this.zahlen.get(0);
    int pos = 0;
    for(int zaehler = 1; zaehler < this.zahlen.size(); zaehler++){
      if (minimum > this.zahlen.get(zaehler)) {
        minimum = this.zahlen.get(zaehler);
        pos = zaehler;
      }
    }
    return new Element(minimum, pos);
  }

  public void sortieren(){
    if (this.zahlen == null) {
      return;
    }
    ArrayList<Integer> ergebnis = new ArrayList<Integer>();
    while (this.zahlen.size() > 0){
      Element minimum = this.minimum();
      ergebnis.add(minimum.getWert());
      this.zahlen.remove(minimum.getPosition());
    }
    this.zahlen = ergebnis;
  }
  
  public void sortierenAusFolien(){
    if (this.zahlen == null) {
      return;
    }
    ArrayList<Integer> ergebnis = new ArrayList<Integer>();
    while (this.zahlen.size() > 0){
      int minimum = this.zahlen.get(0);
      int pos = 0;
      for(int zaehler = 1; zaehler < this.zahlen.size(); zaehler++){
        if (minimum > this.zahlen.get(zaehler)) {
          minimum = this.zahlen.get(zaehler);
          pos = zaehler;
        }
      }
      ergebnis.add(minimum);
      this.zahlen.remove(pos);
    }
    this.zahlen = ergebnis;
  }

  public boolean gibtGleiche(Zahlenanalyse other) {
    ArrayList<Integer> liste = other.getZahlen();
    for (int meinWert: this.zahlen) { //forEach
      //for (Iterator<Integer> meins = this.zahlen.iterator(); meins.hasNext();) {
      //int meinWert = meins.next();
      for (int oWert: liste) { 
        //for (Iterator<Integer> oiter = liste.iterator(); oiter.hasNext();) {
        if (meinWert == oWert) {
          return true;
        }
      }
    }
    return false;
  }  

  public boolean gibtGleicheFor(Zahlenanalyse other) {
    ArrayList<Integer> liste = other.getZahlen();
    for (int zaehler1 = 0; zaehler1 < this.zahlen.size(); zaehler1 = zaehler1 + 1) {
      for (int zaehler2 = 0; zaehler2 < liste.size()
      ; zaehler2 = zaehler2 + 1) {
        if (this.zahlen.get(zaehler1) == liste.get(zaehler2)) {
          return true;
        }
      }
    }
    return false;
  }

  public void zeichZahlenForEigentlich(){
    EinUndAusgabe io = new EinUndAusgabe();
    for(int zaehler = 1;  zaehler <= 10; zaehler++) {
      io.ausgeben(zaehler + "\n");
    }
  }  

  public void zeichZahlenFor(){
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 1;
    for( ; zaehler <= 10; ) {
      io.ausgeben(zaehler + "\n");
      zaehler++;
    }
  }  

  public void zeichZahlen(){
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 1;
    while (zaehler <= 10) {
      io.ausgeben(zaehler + "\n");
      zaehler++;
    }
  }

  public boolean gibtGleicheIt(Zahlenanalyse other) {
    ArrayList<Integer> liste = other.getZahlen();
    Iterator<Integer> meins = this.zahlen.iterator();
    while (meins.hasNext()) {
      int meinWert = meins.next();
      Iterator<Integer> oiter = liste.iterator();
      while (oiter.hasNext()) {
        if (meinWert == oiter.next()) {
          return true;
        }
      }
    }
    return false;
  }

  // Achtung, hier noch keine null-Werte beruecksichtigt; spaeter :)
  public boolean gibtGleicheStandard(Zahlenanalyse other) {
    ArrayList<Integer> liste = other.getZahlen();
    int zaehler1 = 0;
    while (zaehler1 < this.zahlen.size()) {
      int zaehler2 = 0;
      while (zaehler2 < liste.size()) {
        if (this.zahlen.get(zaehler1).equals(liste.get(zaehler2))) {
          return true;
        }
        zaehler2 = zaehler2 + 1;
      }
      zaehler1 = zaehler1 + 1;
    }
    return false;
  }

  public Zahlenanalyse(ArrayList<Integer> zahlen) {
    this.zahlen = zahlen;
  }

  public Zahlenanalyse(ArrayList<Integer> zahlen, String name) {
    this(zahlen);
    this.name = name;
  }

  public Zahlenanalyse() {
    this.zahlen = new ArrayList<Integer>();
  }  

  public ArrayList<Integer> getZahlen() {
    return this.zahlen;
  }

  public void setZahlen(ArrayList<Integer> zahlen) {
    this.zahlen = zahlen;
  }

  public String getName() {
    return this.name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String toString(){
    return this.name + ": " + this.zahlen;
  }

  public void hinzufuegen(int wert){
    this.zahlen.add(wert);
  }

  public void zeigeZahlen(int start, int ende) {
    int zaehler = start;
    EinUndAusgabe io = new EinUndAusgabe();
    while (zaehler <= ende) {
      io.ausgeben(" " + zaehler);
      zaehler = zaehler + 1;
    }
  }

  public void zeigeZahlenFor(int start, int ende) {
    EinUndAusgabe io = new EinUndAusgabe();
    for (int zaehler = start; zaehler <= ende; zaehler = zaehler + 1) {
      io.ausgeben(" " + zaehler);
    }
  }

  // schmuddelige Nutzung der Parameter
  public void zeigeZahlenX(int start, int ende) {
    EinUndAusgabe io = new EinUndAusgabe();
    while (start <= ende) {
      io.ausgeben(" " + start);
      start = start + 1;
    }
  }

  public void zeigeGeradeZahlen(int start, int ende) {
    int zaehler = start;
    EinUndAusgabe io = new EinUndAusgabe();
    while (zaehler <= ende) {
      if (zaehler % 2 == 0) {
        io.ausgeben(" " + zaehler);
      }
      zaehler = zaehler + 1;
    }
  }

  public void geradeZahlenAus(int start, int ende) {
    if (this.zahlen == null) {
      this.zahlen = new ArrayList<Integer>();
    }
    int zaehler = start;
    while (zaehler <= ende) {
      if (zaehler % 2 == 0) {
        this.zahlen.add(zaehler);
      }
      zaehler = zaehler + 1;
    }
  }

  public void listeUntereinanderAusgeben() {
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 0;
    while (zaehler < this.zahlen.size()) {
      io.ausgeben("\t" + this.zahlen.get(zaehler) + "\n");
      zaehler = zaehler + 1;
    }
  }

  public boolean istPrimzahl0(int zahl) {
    if (zahl < 2) {
      return false;
    }
    boolean ergebnis = true;
    int testwert = 2;
    while (testwert < zahl) {
      if (zahl % testwert == 0) {
        ergebnis = false;
      }
      testwert = testwert + 1;
    }
    return ergebnis;
  }

  public boolean istPrimzahl(int zahl) {
    if (zahl < 2) {
      return false;
    }
    boolean ergebnis = ((zahl % 2 != 0) || (zahl == 2));
    int testwert = 3;
    while (testwert < zahl && ergebnis == true) {
      if (zahl % testwert == 0) {
        ergebnis = false;
      }
      testwert = testwert + 2;
    }
    return ergebnis;
  }

  public void zahlbereichMitPrim(int start, int ende) {
    if (this.zahlen == null) {
      this.zahlen = new ArrayList<Integer>();
    }
    int zaehler = start;
    while (zaehler <= ende) {
      if (istPrimzahl(zaehler)) {
        this.zahlen.add(zaehler);
      }
      zaehler = zaehler + 1;
    }
  }

  public Zahlenanalyse zahlenMitDreiAmEnde() {
    ArrayList<Integer> ergebnis = new ArrayList<Integer>();
    int zaehler = 0;
    if (this.zahlen != null) { // kann man weglassen
      while (zaehler < this.zahlen.size()) {
        int element = this.zahlen.get(zaehler);
        if (element % 10 == 3) {
          ergebnis.add(element);
        }
        zaehler = zaehler + 1;
      }
    }
    return new Zahlenanalyse(ergebnis);
  }

  public void schleifeInSchleife() {
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 0;
    while (zaehler < 5) {
      int zaehler2 = 20;
      while (zaehler2 < 25) {
        io.ausgeben(zaehler + ":" + zaehler2 + " ");
        zaehler2 = zaehler2 + 1;
      }
      zaehler = zaehler + 1;
      io.ausgeben("\n");
    }
  }

  public void strukturiertAusgeben0(int anzahl) {
    if (this.zahlen == null) {
      return;
    }
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 0;
    while (zaehler < this.zahlen.size()) {
      int zeilenzaehler = 0;
      while (zeilenzaehler < anzahl && zaehler < this.zahlen.size()) {
        io.ausgeben("" + this.zahlen.get(zaehler) + "\t");
        zeilenzaehler = zeilenzaehler + 1;
        zaehler = zaehler + 1;
      }
      io.ausgeben("\n");
    }
  }

  public void strukturiertAusgeben(int anzahl) {
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 0;
    while (zaehler < this.zahlen.size()) {
      io.ausgeben("" + this.zahlen.get(zaehler) + "\t");
      zaehler = zaehler + 1;
      if (zaehler % anzahl == 0) {
        io.ausgeben("\n");
      }
    }
  }

  public void listeUntereinanderAusgebenAlt() {
    EinUndAusgabe io = new EinUndAusgabe();
    int zaehler = 0;
    while (zaehler < this.zahlen.size()) {
      io.ausgeben("\t" + this.zahlen.get(zaehler) + "\n");
      zaehler = zaehler + 1;
    }
  }

  public void listeUntereinanderAusgebenIterator() {
    EinUndAusgabe io = new EinUndAusgabe();
    Iterator<Integer> it = this.zahlen.iterator();
    while (it.hasNext()) {
      io.ausgeben("\t" + it.next() + "\n");
    }
  }

  public void listeUntereinanderAusgebenIteratorFor() {
    EinUndAusgabe io = new EinUndAusgabe();
    for (Iterator<Integer> it = this.zahlen.iterator(); it.hasNext();) {
      io.ausgeben("\t" + it.next() + "\n");
    }
  }

  public void listeUntereinanderAusgebenIteratorForEach() {
    EinUndAusgabe io = new EinUndAusgabe();
    for (int el : this.zahlen) {
      io.ausgeben("\t" + el + "\n");
    }
  }
}
