import java.util.ArrayList;

import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;


public class ZahlenanalyseTest{
    private Zahlenanalyse zana42und23;
    private Zahlenanalyse zanaNull;
    private Zahlenanalyse zana23;

    @BeforeEach
    public void setUp() {
        ArrayList<Integer> l1 = new ArrayList<Integer>();
        l1.add(42);
        l1.add(23);
        zana42und23 = new Zahlenanalyse(l1);
        zanaNull = new Zahlenanalyse(null);
        ArrayList<Integer>l2 = new ArrayList<Integer>();
        l2.add(23);
        zana23 = new Zahlenanalyse(l2);
    }
    
    @Test
    public void testZahlenMitDreiAmEnde1(){
        Zahlenanalyse tmp = zana42und23.zahlenMitDreiAmEnde();
        Assertions.assertTrue(tmp.getZahlen().size() == 1);
        Assertions.assertTrue(tmp.getZahlen().get(0) == 23);
    }
    
    @Test
    public void testZahlenMitDreiAmEnde2(){
        Zahlenanalyse tmp = zanaNull.zahlenMitDreiAmEnde();
        Assertions.assertTrue(tmp.getZahlen().size() == 0);
    }
    
    @Test
    public void testZahlenMitDreiAmEnde3(){
        Zahlenanalyse tmp = zana23.zahlenMitDreiAmEnde();
        Assertions.assertTrue(tmp.getZahlen().size() == 1);
        Assertions.assertTrue(tmp.getZahlen().get(0) == 23);
    }
    
    @Test
    public void testgibtGleiche1(){
        Boolean tmp = zana42und23.gibtGleiche(zanaNull);
        Assertions.assertTrue(!tmp);
    }
    
    @Test
    public void testgibtGleiche2(){
        Boolean tmp = zana42und23.gibtGleiche(zana23);
        Assertions.assertTrue(tmp);
    }
    
    @Test
    public void testgibtGleiche3(){
        Boolean tmp = zana23.gibtGleiche(zana42und23); 
        Assertions.assertTrue(!tmp);     //?!?
    }
    
    @Test
    public void testIstPrimzahl1() {
        Boolean nicht42 = zana23.istPrimzahl(42);
        Assertions.assertTrue(!nicht42, "42 ist Primzahl");
    }
    
    @Test
    public void testIstPrimzahl2() {
        Boolean doch41 = zana23.istPrimzahl(41);
        Assertions.assertTrue(doch41, "41 ist keine Primzahl");
    }

    @AfterEach
    public void tearDown() {
    }
    
    /* Version 2
    private Zahlenanalyse zana;
    
    @Before
    public void setUp() {
        zana = new Zahlenanalyse(null);
    }
    
    @Test
    public void testIstPrimzahl1() {
        Boolean nicht42 = zana.istPrimzahl(42);
        Assertions.assertTrue(!nicht42, "42 ist Primzahl");
    }

    @Test
    public void testIstPrimzahl2() {
        Boolean doch41 = zana.istPrimzahl(41);
        Assertions.assertTrue(doch41, "41 ist keine Primzahl");
    }
    */
    
    
    /* Version 1
    @Test
    public void testIstPrimzahl1() {
        Zahlenanalyse zana = new Zahlenanalyse(null);
        Boolean nicht42 = zana.istPrimzahl(42);
        Assertions.assertTrue(!nicht42, "42 ist Primzahl", );
    }

    @Test
    public void testIstPrimzahl2() {
        Zahlenanalyse zana = new Zahlenanalyse(null);
        Boolean doch41 = zana.istPrimzahl(41);
        Assertions.assertTrue(doch41, "41 ist keine Primzahl");
    }
    */
}
